// DrawSDIView.cpp : implementation of the CDrawSDIView class
//

#include "stdafx.h"
#include "DrawSDI.h"

#include "DrawSDIDoc.h"
#include "DrawSDIView.h"
#include ".\drawsdiview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CDrawSDIView

IMPLEMENT_DYNCREATE(CDrawSDIView, CView)

BEGIN_MESSAGE_MAP(CDrawSDIView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CDrawSDIView construction/destruction

CDrawSDIView::CDrawSDIView()
: m_pointPrevPos(0)
{
	// TODO: add construction code here

}

CDrawSDIView::~CDrawSDIView()
{
}

BOOL CDrawSDIView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CDrawSDIView drawing

void CDrawSDIView::OnDraw(CDC* pDC)
{
	CDrawSDIDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here

	//     
	int count = pDoc->GetLineCount();

	//   ,    
	if(count){
		for(int i = 0; i < count; i++){
			MyLine* pLine = pDoc->GetLine(i);
			pLine->Draw(pDC);
		}
	}
}


// CDrawSDIView printing

BOOL CDrawSDIView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDrawSDIView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDrawSDIView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CDrawSDIView diagnostics

#ifdef _DEBUG
void CDrawSDIView::AssertValid() const
{
	CView::AssertValid();
}

void CDrawSDIView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDrawSDIDoc* CDrawSDIView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDrawSDIDoc)));
	return (CDrawSDIDoc*)m_pDocument;
}
#endif //_DEBUG


// CDrawSDIView message handlers

void CDrawSDIView::OnLButtonDown(UINT nFlags, CPoint point)
{
	//  ,     
	//    ,  
	//    
	SetCapture(); //    !!!

	//    
	m_pointPrevPos = point;

	CView::OnLButtonDown(nFlags, point);
}

void CDrawSDIView::OnLButtonUp(UINT nFlags, CPoint point)
{
	//       ,
	//   ,   
	//    
	if(GetCapture() == this)
		ReleaseCapture();

	CView::OnLButtonUp(nFlags, point);
}

void CDrawSDIView::OnMouseMove(UINT nFlags, CPoint point)
{
	//     ,  
	if((nFlags & MK_LBUTTON) == MK_LBUTTON){
		//    ,  
		if(GetCapture() == this){
			//   
			//    
			CClientDC dc(this);
			//         
			//    ,  
			//  -  
			MyLine* pLine = 
				GetDocument()->AddLine(m_pointPrevPos, point);

			//   
			pLine->Draw(&dc);

			//      
			m_pointPrevPos = point;
		} // end of if
	} // end of if

	CView::OnMouseMove(nFlags, point);
}
