// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DrawSDI.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "DrawSDIDoc.h"
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_COLORBAR, OnViewColorbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COLORBAR, OnUpdateViewColorbar)
	ON_CBN_SELCHANGE(IDC_CBWIDTH, OnSelChangeWidth)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_COLOR,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	//     
	//       
	if(!CreateColorBar()){
		TRACE0("Failed to create color toolbar\n");
		return -1;
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	m_wndColorBar.EnableDocking(CBRS_ALIGN_TOP);// !!!
	EnableDocking(CBRS_ALIGN_TOP);

	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_wndColorBar);// !!!

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		 | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_SYSMENU;

	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers


void CMainFrame::OnViewColorbar()
{
/*** !   ,    ***
	//  1
	//    
	bool bVisible = (m_wndColorBar.GetStyle() & WS_VISIBLE);
	//     
	int nShow = (bVisible) ? SW_HIDE : SW_SHOWNORMAL;
	m_wndColorBar.ShowWindow(nShow);
//*****************************************************/

//*** !   ,    ***
	//  2
	//     
	ShowControlBar(&m_wndColorBar
                  ,!m_wndColorBar.IsVisible()
                  ,FALSE);
//*****************************************************/
	//     ,
	//        
	RecalcLayout();//   ,    !
}

void CMainFrame::OnUpdateViewColorbar(CCmdUI *pCmdUI)
{
	//      
	//        
	pCmdUI->SetCheck(m_wndColorBar.IsVisible());
}

//      
bool CMainFrame::CreateColorBar(void)
{
	//    
	//      
	if (!m_wndColorBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY /* | CBRS_SIZE_DYNAMIC */) ||
		!m_wndColorBar.LoadToolBar(IDR_TBCOLOR))
	{
		TRACE0("Failed to create toolbar\n");
		return FALSE;      // fail to create
	}
	//   ID_COLOR_BLACK   
    int iTBCtrlID = m_wndColorBar.CommandToIndex(ID_COLOR_BLACK);
	if(iTBCtrlID >= 0){
		//    , 
		//      
		for(int i = iTBCtrlID; i < (iTBCtrlID + 8); i++)
			m_wndColorBar.SetButtonStyle(i, TBBS_CHECKGROUP);
	}

	//   
	int nWidth = 100;
	int nHeight = 125;

	//   -  
	m_wndColorBar.SetButtonInfo(9, IDC_CBWIDTH, TBBS_SEPARATOR, nWidth);

	//      
	CRect rect;
	m_wndColorBar.GetItemRect(9, &rect);
	rect.bottom = rect.top + nHeight;

	//   
	m_ctrlWidth.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | CBS_DROPDOWNLIST
                      ,rect, &m_wndColorBar, IDC_CBWIDTH);

	//       String Table
	CString str;
	UINT id = IDS_WIDTH_1; // ,   
                           //       1,
	                       //    
	for(; id - IDS_WIDTH_1 < 11; id++) //  11 
		if(str.LoadString(id))
			m_ctrlWidth.AddString((LPCTSTR)str);

	//    
	m_ctrlWidth.SetCurSel(0);

	return TRUE;
}

// -    
void CMainFrame::OnSelChangeWidth(void)
{
	int iIndex = m_ctrlWidth.GetCurSel();
	if(iIndex == CB_ERR)//   
		return;

	int iWidth = iIndex + 1;
	switch(iIndex + 1){ //  
		case  9: iWidth = 16; break;
		case 10: iWidth = 24; break;
		case 11: iWidth = 32;
	}
	
	//   
	CDrawSDIDoc* pDoc = (CDrawSDIDoc*)GetActiveDocument();
	if(pDoc) //   
		pDoc->SetWidth(iWidth); //    
}
